<template>
  <div
    class="ob-collapse__item"
    :class="{
      'ob-collapse__item--active': isActive,
      'ob-collapse__item--disabled': disabled
    }"
  >
    <div
      class="ob-collapse__header"
      @click="toggle"
    >
      <i class="icon chevron-up ob-collapse__icon" />
      <slot
        v-if="$slots.title"
        name="title"
      />
      <div v-else>
        {{ title }}
      </div>
    </div>
    <div
      v-show="isActive"
      class="ob-collapse__body"
    >
      <div class="ob-collapse__content">
        <slot />
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: 'ObCollapseItem',
  props: {
    title: {
      type: String,
      default: ''
    },
    name: {
      type: String
    },
    disabled: {
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      index: 0,
      isActive: false
    }
  },
  methods: {
    toggle () {
      if (this.disabled) return false
      this.$parent.toggle({
        name: this.name || this.index,
        isActive: this.isActive
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.ob-collapse__item:last-of-type {
  border-bottom: none
}

.ob-collapse__item--active > .ob-collapse__header .ob-collapse__icon {
  -webkit-transform: rotate(180deg);
  transform: rotate(180deg)
}

.ob-collapse__item--disabled .ob-collapse__header {
  color: $gray-window;
  cursor: not-allowed;

  .ob-collapse__icon {
    color: inherit;
  }
}

.ob-collapse__header {
  position: relative;
  padding: 11px 20px 11px 44px;
  color: $blue-700;
  background-color: $light-lavender;
  border-top: 1px solid rgba($blue-700, .1);
  cursor: pointer;
  font-weight: bold;
  font-size: 16px;
  line-height: 20px;
  letter-spacing: 0.2px;

  .ob-collapse__icon {
    -webkit-transition: all .3s;
    transition: all .3s
  }
}

.ob-collapse__icon {
  position: absolute;
  top: 14px;
  left: 16px;
  font-size: 16px;
  font-weight: 700
}

.ob-collapse__body {
  will-change: height
}

.ob-collapse__content {
  padding: 20px;
  overflow: hidden
}
</style>
